<template>
  <div class="app-container">
    <div class="menuList">
      <div class="menuList-t">
        <div class="menuList-t-l">
          <span>班次：</span>
          <el-radio-group v-model="menuRadio" size="small" @change="changeMenu">
            <el-radio-button v-if="maxTime.isTime1" label="一班">一班</el-radio-button>
            <el-radio-button v-if="maxTime.isTime2" label="二班">二班</el-radio-button>
            <el-radio-button v-if="maxTime.isTime3" label="三班">三班</el-radio-button>
            <el-radio-button v-if="maxTime.isTime4" label="四班">四班</el-radio-button>
          </el-radio-group>
        </div>
        <div class="menuList-t-r">
          <div v-if="!isBarracks" class="menuList-t-r-l" @click="clickBarracks(2);">栏舍计划统计-展开<i class="el-icon-arrow-down" /></div>
          <div v-if="isBarracks" class="menuList-t-r-r" @click="clickBarracks(1);">栏舍计划统计-收起<i class="el-icon-arrow-up" /></div>
          <div v-if="isBarracks" class="columnHouse">
            <div class="smallTable">
              <el-table
                :list-loading="smallMenu.listLoading"
                element-loading-text="给我一点时间"
                :data="smallMenu.list"
                :row-style="rowStyle2"
                :cell-style="cellStyle2"
                :header-row-style="headerRowStyle2"
                :header-cell-style="headerCellStyle2"
                show-summary
                sum-text="总栏舍"
              >
                <el-table-column label="配方/班次" min-width="80px" align="center" prop="tname" />
                <el-table-column label="总数" min-width="50px" align="center" prop="usedsum" />
                <el-table-column v-if="maxTime.isTime1" label="第一班未分配" min-width="105px" align="center" prop="onetime" />
                <el-table-column v-if="maxTime.isTime2" label="第二班未分配" min-width="105px" align="center" prop="twotime" />
                <el-table-column v-if="maxTime.isTime3" label="第三班未分配" min-width="105px" align="center" prop="threetime" />
                <el-table-column v-if="maxTime.isTime4" label="第四班未分配" min-width="105px" align="center" prop="fourtime" />
              </el-table>
            </div>
          </div>
        </div>
      </div>
      <div class="menuList-b">
        <ul v-loading="listLoadingTimes" class="draggableList">
          <li v-for="element in MenuList" :key="element.arrid">
            <span v-if="element.isShowTitle" class="draggableTitle">{{ element.ftname }}:</span>
            <draggable id="1" data-source="juju1" :list="element.arrList" class="list-group1" draggable=".item" group="a" :move="move" @change="changeLog" @start="start" @end="end">
              <div v-for="item in element.arrList" :key="item.id" class="list-group-item1 item" style="width: 88px;float: left;margin:5px 5px;height: 36px;">
                <div style="position: relative;">
                  <el-tooltip placement="top" class="list-group-item1 item" style="height: 18px;line-height: 18px;" :style="{'background':item.background}">
                    <div slot="content">{{ item.barname }}</div>
                    <div class="draggableName">{{ item.barname }}</div>
                  </el-tooltip>
                  <div class="draggableWeight" :style="{ background: 'rgba('+item.background2+ ',0.1)' }">

                    <!-- <span v-if="item.isfill==1" style="background: #009C69;color:#fff;position: absolute;left: 0;top: 18px;">补</span> -->
                    {{ item.weight }}
                  </div>
                </div>
              </div>
            </draggable>
          </li>
        </ul>
      </div>
    </div>

    <div class="operation" style="width: 100%; border-top: 2px solid #d8dce5; box-shadow: 0 1px 6px 0 rgba(0, 0, 0, 0.12), 0 0 6px 0 rgba(0, 0, 0, 0.04)">
      <el-button class="success" icon="el-icon-plus" style="float:left;" @click="handleCreate">新增车次</el-button>
      <el-button class="danger" icon="el-icon-delete" style="float:left;" @click="handleReduceTrains">减少车次</el-button>
    </div>

    <div class="table">
      <el-table
        id="table"
        :key="table.tableKey"
        ref="table"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        highlight-current-row
        style="width: 100%;"
        :height="height"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        row-key="id"
        @selection-change="handleSelect"
      >
        <el-table-column type="selection" width="50" />
        <el-table-column label="车次" width="75px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.sort }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.sort" type="number" placeholder="车次" class="filter-item" style="display: inline-block;width: 95%;" />
          </template>
        </el-table-column>
        <el-table-column label="TMR编号" width="100px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.tmrname }}</span>
            <el-select v-if="scope.row.Edit" v-model="scope.row.tmrid" placeholder="TMR编号" class="filter-item" style="width:95%;" @change="(value)=> {changeTMRNumber(value, scope.row)}">
              <el-option v-for="item in TMRNumberList" :key="item.id" :label="item.eqcode" :value="item.id" />
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="描述" width="100px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.display }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.display" type="textarea" :autosize="{ minRows: 1.3, maxRows: 4}" placeholder="描述" maxlength="255" class="filter-item" style="display: inline-block;width: 95%;" />
          </template>
        </el-table-column>
        <el-table-column label="生效" width="90px" align="center">
          <template slot-scope="scope">
            <el-switch v-model="scope.row.sel" :disabled="scope.row.NoEdit" active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0" @change="handleTakeEffectChange(scope.$index, scope.row)" />
          </template>
        </el-table-column>
        <el-table-column label="班次" width="90px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.timesstr }}</span>
            <el-select v-if="scope.row.Edit" v-model="scope.row.times" :disabled="scope.row.Disabled" placeholder="班次" class="filter-item" style="width:95%;">
              <el-option v-for="item in frequencyList" :key="item.id" :label="item.name" :value="item.id" />
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="时间" width="110px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.begintime }}</span>
            <el-time-picker v-if="scope.row.Edit" v-model="scope.row.begintime" type="datetime" placeholder="选择时间" format="HH:mm" value-format="HH:mm" style="display: inline-block;width: 95%;" />
          </template>
        </el-table-column>
        <el-table-column label="最大重量" width="80px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.maxweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="合计重量" width="80px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.sumweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="模板配方" width="120px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.ftname }}</span>
            <el-select v-if="scope.row.Edit" v-model="scope.row.ftid" :disabled="scope.row.Disabled" placeholder="模板配方" class="filter-item" style="width:95%;" @change="(value)=> {changeTemplateFormulation(value, scope.row)}">
              <el-option v-for="item in templateFormulationList" :key="item.id" :label="item.tname" :value="item.id" />
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="是否提前小料拆分" width="150px" align="center">
          <template slot-scope="scope">
            <el-switch v-model="scope.row.issplit" :disabled="scope.row.NoEdit" active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0" @change="handleIssplitChange(scope.$index, scope.row)" />
          </template>
        </el-table-column>
        <el-table-column label="撒料" width="950px" align="center">
          <template slot-scope="scope">
            <draggable id="2" data-source="juju" :list="scope.row.arrList" class="list-group2" draggable=".item" group="a" :move="move2" @change="changeLog2(scope.row)" @start="start2" @end="end2(scope.row)">
              <div v-for="element in scope.row.arrList" :key="element.name" class="list-group-item2 item">
                <div class="arr-l" :style="{'background':element.tbackground}">
                  <div class="arr-l-t">
                    <div class="arr-l-t-t" />
                    <el-select v-model="element.tmrid" placeholder="撒料设备" class="arr-l-t-b el-icon-arrow-down" @change="(value)=> {changeEquipment(value, scope.row,element.fttype,element.id)}">
                      <el-option v-for="item in equipmentList" :key="item.id" :disabled="table.myTemp.isUpdateSave || scope.row.havebutton == 1" :label="item.tmrmix" :value="item.id" />
                    </el-select>
                  </div>
                  <div class="arr-l-b">
                    <el-tooltip placement="top" class="list-group-item1 item" style="height: 18px;line-height: 18px;">
                      <div slot="content">{{ element.tmrname }}</div>
                      <div class="tmrname">{{ element.tmrname }}</div>
                    </el-tooltip>
                  </div>
                  <!-- <div v-if="element.fttype==0" style="background: #009C69;position:absolute;bottom: 0;left: 0;">补</div> -->
                </div>
                <div class="arr-r">
                  <div class="arr-r-l">
                    <el-tooltip placement="top">
                      <div slot="content">{{ element.barname }}</div>
                      <div class="barname">{{ element.barname }}</div>
                    </el-tooltip>
                  </div>
                  <div class="arr-r-c">-</div>
                  <div class="arr-r-r">
                    <el-tooltip v-show="!element.isWeight" placement="top">
                      <div slot="content">{{ element.weight }}</div>
                      <div class="weight" @dblclick="dbclickWeight(element,scope.row)">{{ element.weight }}</div>
                    </el-tooltip>
                    <el-tooltip v-show="element.isWeight" placement="top">
                      <div slot="content">{{ element.weight }}</div>
                      <input ref="weight" v-model="element.weight" v-focus="element.focusState" type="number" placeholder="重量" step="0.01" class="filter-item2" style="display: inline-block;width: 95%;border: 1px solid #e6e6e6;" @blur="(value)=> {blurWeight(scope.row,element.fttype,element.id)}">
                    </el-tooltip>
                  </div>
                </div>
                <div class="arr-t" :style="{'background':element.background}">
                  <i class="el-icon-close" style="position: absolute;right: 0;" @click="handleFLDelete(element,scope.row)" />
                </div>
              </div>
            </draggable>
          </template>
        </el-table-column>

        <el-table-column align="center" width="100" label="操作" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button v-if="row.isCreate" :disabled="isokDisable" icon="el-icon-folder-checked" class="miniSuccess" @click="createData(row)" />
            <span v-if="row.isCreate" class="centerSpan">|</span>
            <el-button v-if="row.isCreate" class="minCancel" icon="el-icon-close" @click="createCancel(row)" />
            <el-button v-if="row.isUpdate" :disabled="row.havebutton == 1" class="miniSuccess" icon="el-icon-edit-outline" @click="handleUpdate(row)" />
            <span v-if="row.isUpdate" class="centerSpan">|</span>
            <el-button v-if="row.isUpdate" :disabled="row.havebutton == 1" class="miniDanger" icon="el-icon-delete" @click="handleRowDelete(row)" />
            <el-button v-if="row.isUpdateSave" :disabled="isokDisable" icon="el-icon-folder-checked" class="miniSuccess" @click="updateData(row)" />
            <span v-if="row.isUpdateSave" class="centerSpan">|</span>
            <el-button v-if="row.isUpdateSave" class="minCancel" icon="el-icon-close" @click="updateCancel(row)" />
          </template>
        </el-table-column>
      </el-table>
    </div>
  </div>
</template>

<script>
import { GetDataByName, GetArrList, PostDataByName, failproccess, ExecDataByConfig } from '@/api/common'
import draggable from 'vuedraggable'
import Sortable from 'sortablejs'
import Cookies from 'js-cookie'
import { MessageBox } from 'element-ui'
export default {
  name: 'MaterialIssuancePlan',
  display: 'Two list header slot',
  order: 14,
  components: { draggable },
  directives: {
    focus: {
      update: function(el, { value }) {
        if (value) {
          el.focus()
        }
      }
    }
  },
  props: {
    show: { type: Boolean, default: false }, // 弹框可见标志
    parentDate: { type: String, defalut: '' }
  },
  data() {
    return {
      date: '',
      isBarracks: false,
      requestParams: {
        name: 'getTMRListEnableType', offset: 0, parammaps: { pastureid: Cookies.get('pastureid'), eqtype: '1' }
      },
      requestParams2: {
        name: 'getTMRListEnableTypeAll', offset: 0, parammaps: { pastureid: Cookies.get('pastureid'), eqtype: '1' }
      },
      requestParams3: {
        name: 'getFTSWList', offset: 0, parammaps: { pastureid: Cookies.get('pastureid') }
      },
      equipmentList: [], // 撒料设备
      TMRNumberList: [], // TMR编号
      frequencyList: [], // 班次
      templateFormulationList: [], // 模板配方

      // 班次
      maxTime: {
        getMaxTimesParm: {
          name: 'getSysoptEnable',
          page: 1,
          offset: 1,
          pagecount: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            inforname: 'times'
          }
        },
        // 班次
        isTime1: false,
        isTime2: false,
        isTime3: false,
        isTime4: false
      },

      table: {
        getdataListParm: {
          name: 'getLppListdate',
          name1: 'getLppdListdate',
          page: 1,
          offset: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        list: [],
        total: 0,
        tableKey: 0,
        listLoading: false,
        tabClickIndex: null, // 点击的单元格
        tabClickLabel: '', // 当前点击的列名
        temp: {},
        move1: '',
        changeList: [],
        startObj: {},
        isGoing: false,
        myTemp: {}
      },
      selectList: [], // 选中数据

      // 班次
      menuRadio: '一班',
      MenuList: [], // 配单列表
      getdataListParmTimes: {
        name: 'geFTListByFPdate',
        name1: 'geFTListByFPDetaildate',
        page: 1,
        offset: 1,
        returntype: 'Map',
        parammaps: {
          pastureid: Cookies.get('pastureid'),
          times: '1'
        }
      },
      listLoadingTimes: false,

      // 栏舍统计
      isLeftButton: true, // 向左
      isRightButton: false, // 向右
      rowStyle2: { maxHeight: 20 + 'px', height: 20 + 'px' },
      cellStyle2: { padding: 0 + 'px' },
      headerRowStyle2: { maxHeight: 20 + 'px', height: 20 + 'px' },
      headerCellStyle2: { padding: 0 + 'px' },
      smallMenu: {
        getdataListParm: {
          name: 'getLppUseSUMListdate',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        total: 0,
        tableKey: 0,
        listLoading: false,
        list: []
      },
      // 自动生成
      automaticGeneration: {
        dialogFormVisible: false,
        dialogStatus: ''
      },
      historyRecord: {
        dialogFormVisible: false,
        dialogStatus: '',
        myComponent: null
      },
      textMap: {
        automaticGeneration: '提示',
        historyRecord: '历史记录'
      },
      isokDisable: false,
      requestParam: {},
      height: document.body.clientHeight - 255 - 50, // table高度
      // height: document.body.clientHeight - 450 - 50, // table高度
      rowStyle: { maxHeight: 45 + 'px', height: 40 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      dropState: false
    }
  },
  watch: {
    // 监听show,visible 随着show变化而变化
    show: {
      immediate: true,
      handler(newVal, oldVal) {
        console.log('newVal-show', newVal)
      }
    },
    parentDate: {
      immediate: true,
      handler(newVal, oldVal) {
        console.log('newVal-show', newVal)
        this.date = newVal
      }
    }
  },
  created() {
    this.getIsDisplay()
    this.getDownList()
  },
  methods: {
    clickBarracks(item) {
      this.isBarracks = !this.isBarracks
    },
    // 下拉列表
    getDownList() {
      GetDataByName(this.requestParams).then(response => {
        if (response.data !== null) {
          this.TMRNumberList = response.data.list
        } else {
          this.TMRNumberList = []
        }
      })
      GetDataByName(this.requestParams2).then(response => {
        if (response.data !== null) {
          this.equipmentList = response.data.list
        } else {
          this.equipmentList = []
        }
      })
      GetDataByName(this.requestParams3).then(response => {
        if (response.data !== null) {
          this.templateFormulationList = response.data.list
        } else {
          this.templateFormulationList = []
        }
      })
    },

    // 显示班次
    getIsDisplay() {
      GetDataByName(this.maxTime.getMaxTimesParm).then(response => {
        console.log(response.data.list[0].inforvalue)
        if (response.data.list[0].inforvalue == 1) {
          this.frequencyList = [{ id: '1', name: '第一班' }]
        } else if (response.data.list[0].inforvalue == 2) {
          this.frequencyList = [{ id: '1', name: '第一班' }, { id: '2', name: '第二班' }]
        } else if (response.data.list[0].inforvalue == 3) {
          this.frequencyList = [{ id: '1', name: '第一班' }, { id: '2', name: '第二班' }, { id: '3', name: '第三班' }]
        } else if (response.data.list[0].inforvalue == 4) {
          this.frequencyList = [{ id: '1', name: '第一班' }, { id: '2', name: '第二班' }, { id: '3', name: '第三班' }, { id: '4', name: '第四班' }]
        }
        if (response.data.list !== null) {
          if (response.data.list[0].inforvalue == 1) {
            this.maxTime.isTime1 = true
            this.maxTime.isTime2 = false
            this.maxTime.isTime3 = false
            this.maxTime.isTime4 = false
          } else if (response.data.list[0].inforvalue == 2) {
            this.maxTime.isTime1 = true
            this.maxTime.isTime2 = true
            this.maxTime.isTime3 = false
            this.maxTime.isTime4 = false
          } else if (response.data.list[0].inforvalue == 3) {
            this.maxTime.isTime1 = true
            this.maxTime.isTime2 = true
            this.maxTime.isTime3 = true
            this.maxTime.isTime4 = false
          } else if (response.data.list[0].inforvalue == 4) {
            this.maxTime.isTime1 = true
            this.maxTime.isTime2 = true
            this.maxTime.isTime3 = true
            this.maxTime.isTime4 = true
          }
        } else {
          this.maxTime.isTime1 = false
          this.maxTime.isTime2 = false
          this.maxTime.isTime3 = false
          this.maxTime.isTime4 = false
        }
      })
      this.getList()
      this.getSmallMenuList() // 栏舍统计
      this.getTimesList() // 班次
    },

    // 头部班次
    getTimesList() {
      this.listLoadingTimes = true
      this.getdataListParmTimes.parammaps.date = this.date
      GetArrList(this.getdataListParmTimes).then(response => {
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'isShowTitle', true)
            if (response.data.list[i].arrList == null) {
              this.$set(response.data.list[i], 'isShowTitle', false)
            } else {
              for (let j = 0; j < response.data.list[i].arrList.length; j++) {
                this.$set(response.data.list[i].arrList[j], 'background2', this.colorRgb(response.data.list[i].arrList[j].background))
              }
            }
          }
          this.MenuList = response.data.list
        } else {
          this.MenuList = []
        }
        setTimeout(() => {
          this.listLoadingTimes = false
        }, 100)
      })
    },
    colorRgb(sColor) {
      sColor = sColor.toLowerCase()
      var reg = /^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/
      // 如果是16进制颜色
      if (sColor && reg.test(sColor)) {
        if (sColor.length === 4) {
          var sColorNew = '#'
          for (var i = 1; i < 4; i += 1) {
            sColorNew += sColor.slice(i, i + 1).concat(sColor.slice(i, i + 1))
          }
          sColor = sColorNew
        }
        // 处理六位的颜色值
        var sColorChange = []
        for (var i = 1; i < 7; i += 2) {
          sColorChange.push(parseInt('0x' + sColor.slice(i, i + 2)))
        }
        return sColorChange.join(',')
      }
      return 'rgba(' + sColorChange.join(',') + ')'
    },
    // 切换班次
    changeMenu(val) {
      console.log(val)
      if (this.menuRadio === '一班') {
        this.getdataListParmTimes.parammaps.times = '1'
        this.getTimesList()
      } else if (this.menuRadio === '二班') {
        this.getdataListParmTimes.parammaps.times = '2'
        this.getTimesList()
        this.MenuList = this.twoMenuList
      } else if (this.menuRadio === '三班') {
        this.getdataListParmTimes.parammaps.times = '3'
        this.getTimesList()
      } else if (this.menuRadio === '四班') {
        this.getdataListParmTimes.parammaps.times = '4'
        this.getTimesList()
      }
    },

    // 右侧栏舍统计
    getSmallMenuList() {
      this.smallMenu.listLoading = true
      this.smallMenu.getdataListParm.parammaps.date = this.date
      GetDataByName(this.smallMenu.getdataListParm).then(response => {
        console.log('smallMenu数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            if (response.data.list[i].onetime == undefined) { this.$set(response.data.list[i], 'onetime', 0) } else { response.data.list[i].onetime = parseFloat(response.data.list[i].onetime) }
            if (response.data.list[i].twotime == undefined) { this.$set(response.data.list[i], 'twotime', 0) } else { response.data.list[i].twotime = parseFloat(response.data.list[i].twotime) }
            if (response.data.list[i].threetime == undefined) { this.$set(response.data.list[i], 'threetime', 0) } else { response.data.list[i].threetime = parseFloat(response.data.list[i].threetime) }
            if (response.data.list[i].fourtime == undefined) { this.$set(response.data.list[i], 'fourtime', 0) } else { response.data.list[i].fourtime = parseFloat(response.data.list[i].fourtime) }
            this.$set(response.data.list[i], 'usedsum', response.data.list[i].onetime + response.data.list[i].twotime + response.data.list[i].threetime + response.data.list[i].fourtime)
            this.$set(response.data.list[i], 'all', '')
          }
          this.smallMenu.list = response.data.list
          this.smallMenu.total = response.data.total
        } else {
          this.smallMenu.list = []
        }

        setTimeout(() => {
          this.smallMenu.listLoading = false
        }, 100)
      })
    },

    // table
    getList() {
      this.table.listLoading = true
      this.table.getdataListParm.parammaps.date = this.date
      GetArrList(this.table.getdataListParm).then(response => {
        if (response.data !== null) {
          console.log('table数据', response.data.list)
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'Edit', false) // 编辑
            this.$set(response.data.list[i], 'NoEdit', true) // 不可编辑/输入
            this.$set(response.data.list[i], 'isCreate', false) // 新增操作
            this.$set(response.data.list[i], 'isUpdate', true) // 编辑操作
            this.$set(response.data.list[i], 'isUpdateSave', false) // 编辑保存
            this.$set(response.data.list[i], 'Disabled', true) // 班次/模板配方不可输入

            if (response.data.list[i].arrList == null) {
              this.$set(response.data.list[i], 'Disabled', false)
              this.$set(response.data.list[i], 'arrList', [])
            } else {
              for (let j = 0; j < response.data.list[i].arrList.length; j++) {
                this.$set(response.data.list[i].arrList[j], 'isWeight', false)
                this.$set(response.data.list[i].arrList[j], 'focusState', false)
              }
            }
          }
          this.table.list = response.data.list
          this.rowDrop()
          this.table.changeList = []
          this.table.startObj = {}
          if (response.data.total) {
            this.table.total = response.data.total
          }
        } else {
          this.table.list = []
        }

        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },

    // 行拖拽
    rowDrop() {
      console.log(document.querySelector('#table .el-table__body-wrapper tbody'))
      const tbody = document.querySelector('#table .el-table__body-wrapper tbody')
      const that = this
      var sortable = Sortable.create(tbody, {
        disabled: that.dropState,
        onChoose({ newIndex, oldIndex }) {
          if (that.dropState == true) {
            sortable.destroy()
          }
        },
        onEnd({ newIndex, oldIndex }) {
          const currRow = that.table.list.splice(oldIndex, 1)[0]
          that.table.list.splice(newIndex, 0, currRow)
          console.log('索引', newIndex)
          console.log('拖动数据', currRow)
          console.log('上', that.table.list[newIndex - 1])
          console.log('下', that.table.list[newIndex + 1])
        }
      })
    },

    // TMR编号
    changeTMRNumber(item, row) {
      row.tmrname = this.TMRNumberList.find(obj => obj.id === item).eqcode
      row.maxweight = this.TMRNumberList.find(obj => obj.id === item).maxstirfeed
    },
    // 配方模板
    changeTemplateFormulation(item, row) {
      row.ftname = this.templateFormulationList.find(obj => obj.id === item).tname
    },
    // 增加车次
    handleCreate() {
      console.log(this.table.list)
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit === true) {
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      if (this.table.list.length == 0) {
        this.table.list.unshift({ 'myId': (new Date()).valueOf(), 'Edit': true, 'NoEdit': false, 'isCreate': true, 'isUpdate': false, 'isUpdateSave': false, 'tmrname': '', 'tmrid': '', 'sort': 1, 'sel': 1, 'issplit': 1, 'times': '', 'display': '', 'begintime': '', 'ftname': '', 'ftid': '', 'sumweight': '', 'sumcowcount': '', 'maxweight': '', 'arrList': [] })
      } else {
        this.table.list.unshift({ 'myId': (new Date()).valueOf(), 'Edit': true, 'NoEdit': false, 'isCreate': true, 'isUpdate': false, 'isUpdateSave': false, 'tmrname': '', 'tmrid': '', 'sort': parseInt(this.table.list[this.table.list.length - 1].sort) + 1, 'sel': 1, 'issplit': 1, 'times': '', 'display': '', 'begintime': '', 'ftname': '', 'ftid': '', 'sumweight': '', 'sumcowcount': '', 'maxweight': '', 'arrList': [] })
      }
      // this.$refs.box.scrollTop = 0
      this.$refs.table.bodyWrapper.scrollTop = 0
      this.dropState = true
    },
    createData(row) {
      console.log('点击了新增保存', row)
      this.table.temp.pastureid = Cookies.get('pastureid')
      this.table.temp.tmrname = row.tmrname
      this.table.temp.tmrid = row.tmrid
      this.table.temp.sort = row.sort
      this.table.temp.sel = row.sel
      this.table.temp.issplit = row.issplit
      this.table.temp.times = row.times
      this.table.temp.display = row.display
      this.table.temp.begintime = row.begintime
      this.table.temp.ftname = row.ftname
      this.table.temp.ftid = row.ftid
      this.table.temp.sumweight = 0
      this.table.temp.maxweight = row.maxweight
      this.table.temp.date = this.date

      if (this.table.temp.sort == '' && this.table.temp.tmrid == '' && this.table.temp.times == '' && this.table.temp.ftid == '') {
        this.$message({ type: 'error', message: '车次/TMR编号/班次/模板配方不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.tmrid == '' && this.table.temp.times == '' && this.table.temp.ftid == '') {
        this.$message({ type: 'error', message: 'TMR编号/班次/模板配方不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.times == '' && this.table.temp.ftid == '') {
        this.$message({ type: 'error', message: '班次/模板配方不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.ftid == '') {
        this.$message({ type: 'error', message: '模板配方不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.times == '') {
        this.$message({ type: 'error', message: '班次不能为空', duration: 2000 })
        return false
      }
      for (let i = 0; i < this.table.list.length; i++) {
        if (row.sort == this.table.list[i].sort) {
          if (row.myId !== this.table.list[i].myId) {
            this.$message({ type: 'error', message: '车次不可重复', duration: 2000 })
            return false
          }
        }
      }
      var isInteger = /^\d+$/
      if (this.table.temp.sort !== '') {
        if (!isInteger.test(parseFloat(this.table.temp.sort))) {
          this.$message({ type: 'error', message: '车次请输入整数', duration: 2000 })
          return false
        }
      }

      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam = {}
      this.requestParam.name = 'insertLppdate'
      this.requestParam.parammaps = this.table.temp
      PostDataByName(this.requestParam).then(response => {
        console.log('新增保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.getList()
          this.dropState = false
        } else {
          this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
        }
      })
    },
    createCancel(row) {
      console.log('点击了新增取消')
      this.dropState = false
      for (let i = 0; i < this.table.list.length; i++) {
        if (row.myId === this.table.list[i].myId) {
          var listIndex = this.table.list.indexOf(this.table.list[i])
        }
        if (listIndex > -1) {
          this.table.list.splice(listIndex, 1)
          return
        }
      }
    },

    // 编辑
    handleUpdate(row) {
      console.log(row, '点击了行编辑')
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit == true) {
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      // 编辑true,不可编辑false
      row.Edit = true
      row.NoEdit = false
      // 新增false,编辑false,编辑保存true
      row.isCreate = false
      row.isUpdate = false
      row.isUpdateSave = true
      row.times = String(row.times)
      if (row.sort == undefined) { row.sort = '' }
      if (row.tmrid == undefined || row.tmrname == undefined) {
        row.tmrid = ''
        row.tmrname = ''
      }
      if (row.display == undefined) { row.display = '' }
      if (row.times == undefined) { row.times = '' }
      if (row.begintime == undefined) { row.begintime = '' }
      if (row.ftid == undefined || row.ftname == undefined) {
        row.ftid = ''
        row.ftname = ''
      }
      this.dropState = true
      this.table.myTemp = Object.assign({}, row)
    },
    updateData(row) {
      console.log('点击了编辑保存', row)
      row.isUpdateSave = false
      this.table.myTemp = Object.assign({}, row)
      this.table.temp.pastureid = row.pastureid
      this.table.temp.id = row.id
      this.table.temp.tmrname = row.tmrname
      this.table.temp.tmrid = row.tmrid
      this.table.temp.sort = row.sort
      this.table.temp.sel = row.sel
      this.table.temp.issplit = row.issplit
      this.table.temp.times = row.times
      this.table.temp.display = row.display
      this.table.temp.begintime = row.begintime
      this.table.temp.ftname = row.ftname
      this.table.temp.ftid = row.ftid
      this.table.temp.sumweight = row.sumweight
      this.table.temp.sumcowcount = row.sumcowcount
      this.table.temp.maxweight = row.maxweight
      this.table.temp.date = this.date

      if (this.table.temp.sort == '' && this.table.temp.tmrid == '' && this.table.temp.times == '' && this.table.temp.ftid == '') {
        this.$message({ type: 'error', message: '车次/TMR编号/班次/模板配方不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.tmrid == '' && this.table.temp.times == '' && this.table.temp.ftid == '') {
        this.$message({ type: 'error', message: 'TMR编号/班次/模板配方不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.times == '' && this.table.temp.ftid == '') {
        this.$message({ type: 'error', message: '班次/模板配方不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.ftid == '') {
        this.$message({ type: 'error', message: '模板配方不能为空', duration: 2000 })
        return false
      }
      for (let i = 0; i < this.table.list.length; i++) {
        if (row.sort == this.table.list[i].sort) {
          if (row.id !== this.table.list[i].id) {
            this.$message({ type: 'error', message: '车次不可重复', duration: 2000 })
            return false
          }
        }
      }
      var isInteger = /^\d+$/
      if (this.table.temp.sort !== '') {
        if (!isInteger.test(parseFloat(this.table.temp.sort))) {
          this.$message({ type: 'error', message: '车次请输入整数', duration: 2000 })
          return false
        }
      }

      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam = {}
      this.requestParam.name = 'updateLppdate'
      this.requestParam.parammaps = this.table.temp
      PostDataByName(this.requestParam).then(response => {
        console.log('编辑保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.getList()
          this.dropState = false
        } else {
          this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
        }
      })
    },
    updateCancel(row) {
      console.log('点击了编辑取消')
      // 编辑false,不可编辑true
      row.Edit = false
      row.NoEdit = true
      // 新增false,编辑true,编辑保存false
      row.isCreate = false
      row.isUpdate = true
      row.isUpdateSave = false
      this.dropState = false
      this.table.myTemp = Object.assign({}, row)
    },

    // 配方
    changeLog: function(evt) {
      console.log('change1', evt)
    },
    start(evt) {
      console.log('start1', evt)
      this.$set(this.table.startObj, 'from', evt.from.className)
      this.$set(this.table.startObj, 'to', evt.from.className)
    },
    end(evt) {
      console.log('end1', evt)
    },
    move(evt, originalEvent) {
      if (originalEvent.target.className === 'list-group-item1 item' || originalEvent.target.className === 'draggableWeight') {
        return false
      }
      console.log(evt)
      this.table.move1 = evt.draggedContext.element
    },

    start2(evt) {
      console.log('start2', evt)
      this.$set(this.table.startObj, 'from', evt.from.className)
      this.$set(this.table.startObj, 'to', evt.from.className)
    },
    move2(evt, originalEvent) {
      // console.log(evt, originalEvent)
      if (originalEvent.target.className === 'list-group-item1 item' || originalEvent.target.className === 'draggableWeight') {
        return false
      }
      this.table.move1 = evt.draggedContext.element
    },
    end2(evt) {
      // console.log(evt)
      console.log('end2', evt)
    },
    // 撒料位
    changeLog2(evt) {
      // console.log(this.table.startObj)
      console.log(evt, 'evt-----')
      if (evt.havebutton == 1) {
        this.$message({ type: 'error', message: '该车次计划已执行，不允许修改', duration: 2000 })
        this.getTimesList()
        this.getSmallMenuList()
        this.getList()
        return false
      }
      this.table.changeList.push(evt)
      evt = this.table.changeList[0]
      if (evt.arrList.length == 1) {
        evt.arrList[0].sort = 0
      } else if (evt.arrList.length > 1) {
        for (let i = 0; i < evt.arrList.length; i++) {
          if (evt.arrList[i].id == this.table.move1.id && evt.arrList[i].fttype == this.table.move1.fttype) {
            if (evt.arrList[i - 1] == undefined) {
              evt.arrList[i].sort = 0
              evt.sort = 0
            } else {
              evt.arrList[i].sort = parseFloat(evt.arrList[i - 1].sort) + 1
              evt.sort = parseFloat(evt.arrList[i - 1].sort) + 1
            }
          }
        }
      }
      console.log(evt.arrList, '==========1')
      console.log(evt, '==========2')
      if (this.table.startObj.from == 'list-group1' && this.table.startObj.to == 'list-group1') {
        this.requestParam = {}
        this.requestParam.common = { 'returnmap': '0' }
        this.requestParam.data = []
        this.requestParam.data[0] = { 'name': 'checkLLPDetailInsertdate', 'type': 'v', 'parammaps': {
          pastureid: this.table.move1.pastureid,
          barid: this.table.move1.barid,
          lppid: evt.id,
          times: evt.times,
          ftid: this.table.move1.ftid,
          ptsid: this.table.move1.ptsid,
          ptid: this.table.move1.ptid,
          fttype: this.table.move1.fttype,
          timesTem: this.table.move1.times,
          date: this.date
        }}
        this.requestParam.data[1] = { 'name': 'updateLpplandtlSortsdate', 'type': 'e', 'parammaps': {
          pastureid: evt.pastureid,
          sort: evt.sort,
          lppid: evt.id,
          date: this.date
        }}
        this.requestParam.data[2] = { 'name': 'insertLppddate', 'type': 'e', 'parammaps': {
          pastureid: evt.pastureid,
          lppid: evt.id,
          barid: this.table.move1.barid,
          barname: this.table.move1.barname,
          fpdid: this.table.move1.id,
          fttype: this.table.move1.fttype,
          lweight: this.table.move1.weight,
          sort: evt.sort,
          tmrid: evt.tmrid,
          tmrname: evt.tmrname,
          background: this.table.move1.background,
          ccountradio: this.table.move1.ccountradio,
          cowcount: this.table.move1.cowcount,
          date: this.date
        }}
        this.requestParam.data[3] = { 'name': 'updateFpdetailUsedate', 'type': 'e', 'parammaps': {
          pastureid: this.table.move1.pastureid,
          id: this.table.move1.id,
          fttype: this.table.move1.fttype,
          lweight: this.table.move1.weight,
          date: this.date
        }}

        console.log('撒料位上-下新增', this.requestParam)
        ExecDataByConfig(this.requestParam).then(response => {
          console.log('撒料位新增保存发送参数', this.requestParam)
          if (response.msg === 'fail') {
            this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
            this.getTimesList()
            this.getSmallMenuList()
            this.getList()
          } else {
            this.$notify({ title: '', message: '保存成功', type: 'success', duration: 2000 })
            this.getList()
            this.getSmallMenuList()
          }
        })
      } else if (this.table.startObj.from == 'list-group2' && this.table.startObj.to == 'list-group2') {
        if (this.table.changeList.length == 1) {
          this.requestParam = {}
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'checkLLPDetailInsertdate', 'type': 'v', 'parammaps': {
            pastureid: this.table.move1.pastureid,
            barid: this.table.move1.barid,
            lppid: evt.id,
            times: evt.times,
            ftid: this.table.move1.ftid,
            ptsid: this.table.move1.ptsid,
            ptid: this.table.move1.ptid,
            fttype: this.table.move1.fttype,
            timesTem: evt.times,
            date: this.date
          }}
          this.requestParam.data[1] = { 'name': 'updateLpplandtlSortsdate', 'type': 'e', 'parammaps': {
            pastureid: evt.pastureid,
            sort: evt.sort,
            lppid: evt.id,
            date: this.date
          }}
          this.requestParam.data[2] = { 'name': 'deleteLppddate', 'type': 'e', 'parammaps': {
            pastureid: evt.pastureid,
            id: this.table.move1.id,
            date: this.date
          }}
          this.requestParam.data[3] = { 'name': 'insertLppddate', 'type': 'e', 'parammaps': {
            pastureid: evt.pastureid,
            lppid: evt.id,
            barid: this.table.move1.barid,
            barname: this.table.move1.barname,
            fpdid: this.table.move1.fpdid,
            fttype: this.table.move1.fttype,
            lweight: this.table.move1.weight,
            sort: evt.sort,
            tmrid: evt.tmrid,
            tmrname: evt.tmrname,
            background: this.table.move1.background,
            ccountradio: this.table.move1.ccountradio,
            cowcount: this.table.move1.cowcount,
            date: this.date
          }}
          console.log('撒料位下-下新增', this.requestParam)
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('撒料位新增保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              this.getTimesList()
              this.getSmallMenuList()
              this.getList()
            } else {
              this.$notify({ title: '', message: '保存成功', type: 'success', duration: 2000 })
              this.getList()
              this.getSmallMenuList()
            }
          })
        } else if (this.table.changeList.length == 1) {
          if (this.table.isGoing == true) {
            console.log(11111)
            this.requestParam.common = { 'returnmap': '0' }
            this.requestParam.data = []
            this.requestParam.data[0] = { 'name': 'checkLLPDetailInsertdate', 'type': 'e', 'parammaps': {
              pastureid: evt.pastureid,
              sort: evt.sort,
              lppid: evt.id,
              date: this.date
            }}
            this.requestParam.data[1] = { 'name': 'deleteLppddate', 'type': 'e', 'parammaps': {
              pastureid: evt.pastureid,
              id: this.table.move1.id,
              date: this.date
            }}
            this.requestParam.data[2] = { 'name': 'insertLppddate', 'type': 'e', 'parammaps': {
              pastureid: evt.pastureid,
              lppid: evt.id,
              barid: this.table.move1.barid,
              barname: this.table.move1.barname,
              fpdid: this.table.move1.id,
              fttype: this.table.move1.fttype,
              lweight: this.table.move1.weight,
              sort: evt.sort,
              tmrid: evt.tmrid,
              tmrname: evt.tmrname,
              background: this.table.move1.background,
              date: this.date
            }}
            this.requestParam.data[3] = { 'name': 'updateFpdetailUsedate', 'type': 'e', 'parammaps': {
              pastureid: this.table.move1.pastureid,
              id: this.table.move1.id,
              fttype: this.table.move1.fttype,
              statue: 1,
              date: this.date
            }}

            console.log('撒料位新增', this.requestParam)
            ExecDataByConfig(this.requestParam).then(response => {
              console.log('撒料位新增保存发送参数', this.requestParam)
              if (response.msg === 'fail') {
                this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
                this.getTimesList()
                this.getList()
              } else {
                this.$notify({ title: '', message: '保存成功', type: 'success', duration: 2000 })
                this.getList()
              }
            })
            this.table.isGoing = false
          } else {
            this.table.isGoing = true
          }
        }
      }
    },

    // 编辑-撒料设备
    changeEquipment(item, row, fttype, myid) {
      var objList = {}
      for (let i = 0; i < row.arrList.length; i++) {
        row.arrList[i].tmrname = this.equipmentList.find(obj => obj.id === item).tname
        if (row.arrList[i].fttype == fttype && row.arrList[i].id == myid) {
          objList = row.arrList[i]
        }
        if (row.tmrid == row.arrList[i].tmrid) {
          if (row.tmrid !== item) {
            this.$message({ type: 'warning', message: '混料设备不可与其它撒料设备同时选择', duration: 2000 })
            this.getList()
            return false
          }
        } else {
          if (row.tmrid == item) {
            this.$message({ type: 'warning', message: '混料设备不可与其它撒料设备同时选择', duration: 2000 })
            this.getList()
            return false
          }
        }
      }
      console.log(row)
      this.requestParam = {}
      this.requestParam.common = { 'returnmap': '0' }
      this.requestParam.data = []
      this.requestParam.data[0] = { 'name': 'updateLppddate', 'type': 'e', 'parammaps': {
        pastureid: row.pastureid,
        lppid: row.id,
        barid: objList.barid,
        barname: objList.barname,
        fpdid: objList.fpdid,
        fttype: objList.fttype,
        lweight: objList.weight,
        sort: objList.sort,
        tmrid: objList.tmrid,
        tmrname: objList.tmrname,
        background: objList.background,
        id: objList.id,
        date: this.date
      }}
      ExecDataByConfig(this.requestParam).then(response => {
        console.log('编辑保存发送参数', this.requestParam)
        if (response.msg === 'fail') {
          this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
        } else {
          this.$notify({ title: '', message: '保存成功', type: 'success', duration: 2000 })
          this.getList()
          this.getTimesList()
        }
      })
    },
    dbclickWeight(row, row2) {
      console.log(row2, 'row2')
      if (row2.havebutton == 1) {
        return false
      }
      if (this.table.myTemp.isUpdateSave == true) {
        return false
      }
      console.log(row)
      row.isWeight = true
      row.focusState = true
      this.dropState = true
      this.myStart2 = false
      this.myMove2 = false
      this.myEnd2 = false
    },
    // 编辑-重量
    blurWeight(row, fttype, myid) {
      var objList = {}
      for (let i = 0; i < row.arrList.length; i++) {
        if (row.arrList[i].fttype == fttype && row.arrList[i].id == myid) {
          objList = row.arrList[i]
        }
      }
      if (objList.weight == '') { objList.weight = 0 }
      this.requestParam = {}
      this.requestParam.common = { 'returnmap': '0' }
      this.requestParam.data = []
      this.requestParam.data[0] = { 'name': 'checkFPdLeftWdate', 'type': 'v', 'parammaps': {
        pastureid: objList.pastureid,
        fpdid: objList.fpdid,
        fttype: objList.fttype,
        lweight: String(parseFloat(objList.weight) - parseFloat(objList.lweight)),
        date: this.date
      }}
      this.requestParam.data[1] = { 'name': 'updateLppddate', 'type': 'e', 'parammaps': {
        pastureid: row.pastureid,
        lppid: row.id,
        barid: objList.barid,
        barname: objList.barname,
        fpdid: objList.fpdid,
        fttype: objList.fttype,
        lweight: objList.weight,
        sort: objList.sort,
        tmrid: objList.tmrid,
        tmrname: objList.tmrname,
        background: objList.background,
        id: objList.id,
        date: this.date
      }}
      this.requestParam.data[2] = { 'name': 'updateFpdetailUsedate', 'type': 'e', 'parammaps': {
        pastureid: objList.pastureid,
        id: objList.fpdid,
        fttype: objList.fttype,
        lweight: String(parseFloat(objList.weight) - parseFloat(objList.lweight)),
        date: this.date
      }}

      ExecDataByConfig(this.requestParam).then(response => {
        console.log('编辑保存发送参数', this.requestParam)
        if (response.msg === 'fail') {
          this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
          this.getList()
          this.getTimesList()
        } else {
          this.$notify({ title: '', message: '保存成功', type: 'success', duration: 2000 })
          this.getList()
          this.getTimesList()
        }
      })
    },
    handleTakeEffectChange() {
      console.log('点击了生效')
    },
    handleIssplitChange() {
      console.log('是否提前小料拆分')
    },

    // 撒料位删除
    handleFLDelete(ele, row) {
      if (row.havebutton == 1) {
        return false
      }
      if (this.table.myTemp.isUpdateSave == true) {
        return false
      }
      console.log(ele, row, '点击了撒料删除')
      this.selectList = []
      this.requestParam = {}
      this.requestParam.common = { 'returnmap': '0' }
      this.requestParam.data = []
      this.requestParam.data[0] = { 'name': 'deleteLppddate', 'type': 'e', 'parammaps': {
        pastureid: ele.pastureid,
        id: ele.id,
        date: this.date
      }}
      this.requestParam.data[1] = { 'name': 'updateFpdetailUsedate', 'type': 'e', 'parammaps': {
        pastureid: ele.pastureid,
        id: ele.fpdid,
        fttype: ele.fttype,
        lweight: '-' + parseFloat(ele.weight),
        date: this.date
      }}
      ExecDataByConfig(this.requestParam).then(response => {
        console.log('删除保存发送参数', this.requestParam)
        if (response.msg === 'fail') {
          this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
        } else {
          this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
          this.getList()
          this.getTimesList()
        }
      })
    },

    handleSelect(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    // 减少车次
    handleReduceTrains() {
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择车次', duration: 2000 })
        return false
      } else {
        // 减少对应车次
        for (let i = 0; i < this.selectList.length; i++) {
          if (this.selectList[i].arrList.length > 0) {
            this.$message({ type: 'error', message: '本车次已添加栏舍不可删除', duration: 2000 })
            return false
          }
        }
        MessageBox.confirm('是否确认删除此信息?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam = {}
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotListdate', 'resultmaps': { 'list': this.selectList }}
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = { 'name': 'deleteLppdate', 'type': 'e', 'parammaps': {
            id: '@insertSpotList.id',
            pastureid: '@insertSpotList.pastureid',
            date: this.date
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        })
      }
    },

    // 行内删除
    handleRowDelete(row) {
      console.log(row, '点击了行删除')
      if (row.arrList.length == 0) {
        MessageBox.confirm('是否确认删除此信息?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          this.selectList = []
          this.requestParam = {}
          this.requestParam.name = 'deleteLppdate'
          this.requestParam.parammaps = {}
          this.requestParam.parammaps.pastureid = row.pastureid
          this.requestParam.parammaps.id = row.id
          this.requestParam.parammaps.date = this.date
          PostDataByName(this.requestParam).then(response => {
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        }).catch(() => {
          this.$message({ type: 'info', message: '已取消删除' })
        })
      } else {
        this.$message({ type: 'error', message: '本车次已添加栏舍不可删除', duration: 2000 })
        return false
      }
    },
    handleLeftButton() { // 向左
      this.isLeftButton = false
      this.isRightButton = true
      this.$refs.listR.style.width = '46%'
      this.$refs.listR.style.zIndex = 4
      this.getSmallMenuList()
    },
    handleRightButton() { // 向右
      this.isLeftButton = true
      this.isRightButton = false
      this.$refs.list.style.zIndex = 1
      this.$refs.listR.style.width = '50px'
      this.$refs.listR.style.zIndex = 1
      this.$nextTick(() => {
        this.$refs.listRight.style.zIndex = 1
        this.$refs.listRight2.style.zIndex = 1
      })
    }
  }
}
</script>

<style lang="scss">
  /deep/ :focus {
    outline: 0;
  }
  :focus-visible {
    outline: 0 !important;
  }
  // 下拉框
  .filter-item2 .el-input--suffix .el-input__inner{
    height: 30px !important;
    font-size: 8px;
    padding: 0 2px;
  }
  .filter-item2 .el-input--suffix .el-input__suffix .el-input__suffix-inner .el-input__icon{
    line-height: 30px !important;
  }
  // 输入框
  .filter-item2 .el-input__inner{
    height: 30px !important;
    font-size: 8px;
    padding: 0 2px;
  }
</style>

<style lang="scss">
 .menuList{
    height: 190px;background: red;border-bottom: 2px solid #d8dce5; box-shadow: 0 1px 6px 0 rgba(0, 0, 0, 0.12), 0 0 6px 0 rgba(0, 0, 0, 0.04);
    .menuList-t{
      height: 60px;background: #fff;display: flex;justify:center;align-items:center;display:-webkit-flex; flex-direction: row; flex-wrap: wrap; justify-content: space-between;
      .menuList-t-l{}
      .menuList-t-r{
        display: flex; flex-direction: row; flex-wrap: wrap; justify-content: space-between;position: relative;
        .menuList-t-r-l{
          margin-right:10px;cursor:pointer;width:150px;height: 20px;line-height:20px; text-align: center; background: rgba(25, 138, 244, 0); border: 1px solid #1BBD89; border-radius: 2px;font-size:12px;color: #1BBD89;
        }
        .menuList-t-r-r{
          margin-right:10px;cursor:pointer;width:150px;height: 20px;line-height:20px; text-align: center; background: rgba(25, 138, 244, 0); border: 1px solid #1BBD89; border-radius: 2px;font-size:12px;color: #1BBD89;
        }
        .columnHouse{
          width:650px;background: #fff; box-shadow: 0 0 6px 6px rgba(0, 0, 0, 0.04), 0 0 6px 6px rgba(0, 0, 0, 0.04);position: absolute;right: 0;top: 25px;z-index: 5;
          .el-table {
            height: 250px;
            overflow: auto;
          }
        }
      }

    }
    .menuList-b{
      height: 130px;background: #fff;position: relative;
      ::-webkit-scrollbar{ width: 7px; height: 7px; background-color: #F5F5F5; }
      ::-webkit-scrollbar-track { box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3); -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3); border-radius: 10px; background-color: #F5F5F5; }
      ::-webkit-scrollbar-thumb{ border-radius: 10px; box-shadow: inset 0 0 6px rgba(0, 0, 0, .1); -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, .1); background-color: #c8c8c8; }
      .draggableList{position: absolute;width: 100%;margin: 0 0; height: 130px; list-style: none;padding:0 0;overflow: auto;font-size: 12px;
        .draggableTitle{float: left;width: 105px;white-space: nowrap;overflow: hidden; text-overflow: ellipsis;margin:5px 5px;border-radius: 7px;text-align: center;color:#000;height: 36px;line-height: 36px;}
        li{
          text-align: center;color:#fff;
          .draggableName{display:block;width: 100%;overflow: hidden; text-overflow:ellipsis; white-space: nowrap;}
        }
      }
    }
  }
  .list-group2{
    .list-group-item2{
      width: 220px;height: 50px;overflow: hidden; float: left;margin: 5px 5px;position: relative;
      .arr-t{height: 50px;border-radius:5px 5px;}
      .arr-l{
        float: left;width: 60px;height: 50px;overflow: hidden;border-radius:5px 50% 50% 5px;
        .arr-l-t{
          position: relative;
          .arr-l-t-t{
            width: 0;height: 0; border-top: 26px solid #3479f2; border-right: 26px solid transparent;
          }
          .arr-l-t-b{
            position: absolute;top: 4px;left: 1px;color: #fff;width: 10px; height: 10px;
            .el-input--suffix{
              opacity:0;
              .el-input__inner{height: 10px;}
            }
          }
        }

        .arr-l-b{
          width: 45px;position: absolute;top: 15px;left: 10px;color: #333;font-size: 12px;
          .tmrname{width: 100%;overflow: hidden; text-overflow:ellipsis; white-space: nowrap;}
        }
      }
      .arr-c{position: absolute;top: 0px;left: 0;}
      .arr-r{
        float: right;width: 160px;height: 50px;overflow: hidden;line-height: 50px;
        .arr-r-l{
          float: left;width: 85px;
          .barname{width: 100%;overflow: hidden; text-overflow:ellipsis; white-space: nowrap;}
        }
        .arr-r-c{float: left;width: 10px;}
        .arr-r-r{
          float: left;width: 65px;
          .weight{width: 100%;overflow: hidden; text-overflow:ellipsis; white-space: nowrap;}
        }
      }
    }
  }
</style>
<style>
  .draggableWeight{display:block;line-height: 18px;height: 18px; color: #000; width: 100%; margin: 0 auto;}
</style>
